﻿#region Copyright and License Notice
// Copyright (C)2010-2013 - Rob Levine and other contributors
// http://configgen.codeplex.com
// 
// This file is part of ConfigGen.
// 
// ConfigGen is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// ConfigGen is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License and 
// the GNU Lesser General Public License along with ConfigGen.  
// If not, see <http://www.gnu.org/licenses/>
#endregion

using ConfigGen.ConsoleApp.Core.CommandLineOptionCore;

namespace ConfigGen.ConsoleApp.Core.CommandLineOptions
{
    /// <summary>
    /// Factory for <see cref="ICommandLineOption{T}"/> types, for the ConfigGen application.
    /// </summary>
    public class ConfigGenCommandLineOptionFactory : CommandLineOptionFactory<ConsoleAppPreferences>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ConfigGenCommandLineOptionFactory"/> class and loads the <see cref="ICommandLineOption{T}"/> 
        /// handlers for this factory.
        /// </summary>
        public ConfigGenCommandLineOptionFactory()
        {
            LoadConsoleArgHandler(new OutputDirectory());
            LoadConsoleArgHandler(new DefaultSettingsFile());
            LoadConsoleArgHandler(new SettingsFile());
            LoadConsoleArgHandler(new TemplateFile());
            LoadConsoleArgHandler(new ErrorOnWarnings());
            LoadConsoleArgHandler(new ErrorOnFileChanged());
            LoadConsoleArgHandler(new FlatOutputStructure());
            LoadConsoleArgHandler(new MachineSuffix());
            LoadConsoleArgHandler(new InhibitWrite());
            LoadConsoleArgHandler(new WriteUnchangedFiles());
            LoadConsoleArgHandler(new Verbose());
            LoadConsoleArgHandler(new LocalOnly());
            LoadConsoleArgHandler(new GenerateSpecifiedOnly());
            LoadConsoleArgHandler(new ForceName());
            LoadConsoleArgHandler(new RemoveRootElement());
            LoadConsoleArgHandler(new PrettyPrint());
            LoadConsoleArgHandler(new PrettyPrintLineLength());
            LoadConsoleArgHandler(new DumpSettingsOnly());
            LoadConsoleArgHandler(new DumpSettingsFile());
            LoadConsoleArgHandler(new FilterMachinesByRegex());
        }
    }
}
