﻿#region Copyright and License Notice
// Copyright (C)2010-2013 - Rob Levine and other contributors
// http://configgen.codeplex.com
// 
// This file is part of ConfigGen.
// 
// ConfigGen is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// ConfigGen is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License and 
// the GNU Lesser General Public License along with ConfigGen.  
// If not, see <http://www.gnu.org/licenses/>
#endregion

using System.Collections.Generic;
using System.Security.Cryptography;

namespace ConfigGen.Core.Tests
{
    public class MockHashAlgorithm : HashAlgorithm
    {
        private readonly Queue<byte[]> _hashCode = new Queue<byte[]>();

        public MockHashAlgorithm()
        {
            
        }

        protected override void HashCore(byte[] array, int ibStart, int cbSize)
        {

        }

        protected override byte[] HashFinal()
        {
            return _hashCode.Dequeue();
        }

        public void AddExpectedHash(byte[] hashCode)
        {
            _hashCode.Enqueue(hashCode);    
        }

        public override void Initialize()
        {

        }
    }
}