#region Copyright and License Notice
// Copyright (C)2010-2013 - Rob Levine and other contributors
// http://configgen.codeplex.com
// 
// This file is part of ConfigGen.
// 
// ConfigGen is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// ConfigGen is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License and 
// the GNU Lesser General Public License along with ConfigGen.  
// If not, see <http://www.gnu.org/licenses/>
#endregion

using System;
using ConfigGen.Core.ConfigurationSettings;
using ConfigGen.Core.TemplateLoader;

namespace ConfigGen.Core
{
    /// <summary>
    /// Interface implemented by the single file generator class.
    /// </summary>
    public interface ISingleFileGenerationController
    {
        /// <summary>
        /// Generates a single configuration file from the supplied template loaded, machine settings and
        /// preferences.
        /// </summary>
        /// <param name="templateLoader">Template loader</param>
        /// <param name="currentMachine">Settings for the current machine</param>
        /// <param name="preferences">Preferences for each</param>
        /// <returns>Results from the generation.</returns>
        /// <exception cref="ArgumentNullException">Thrown if any of the parameters are null</exception>
        SingleFileGenerationResults GenerateFile(
            ITemplateLoader templateLoader,
            MachineConfigurationSettings currentMachine,
            Preferences preferences);
    }
}