﻿#region Copyright and License Notice
// Copyright (C)2010-2013 - Rob Levine and other contributors
// http://configgen.codeplex.com
// 
// This file is part of ConfigGen.
// 
// ConfigGen is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// ConfigGen is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License and 
// the GNU Lesser General Public License along with ConfigGen.  
// If not, see <http://www.gnu.org/licenses/>
#endregion
namespace ConfigGen.Core
{
    /// <summary>
    /// 
    /// </summary>
    public abstract class OutputWriterResultsBase
    {
        /// <summary>
        /// Gets or sets the MD5 hash of the old configuration file prior to being overwritted by the generated file. Returns null if no pre-existing file.
        /// </summary>
        /// <value></value>
        public byte[] OldMd5 { get; set; }

        /// <summary>
        /// Gets or sets the MD5 hash of the new generated configuration file.
        /// </summary>
        /// <value></value>
        public byte[] NewMd5 { get; set; }

        /// <summary>
        /// Gets or sets a flag indicating if output was written by the writer.
        /// </summary>
        /// <value></value>
        public bool OutputWritten { get; set; }
    }
}