﻿#region Copyright and License Notice
// Copyright (C)2010-2012 - Rob Levine and other contributors
// http://configgen.codeplex.com
// 
// This file is part of ConfigGen.
// 
// ConfigGen is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// ConfigGen is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License and 
// the GNU Lesser General Public License along with ConfigGen.  
// If not, see <http://www.gnu.org/licenses/>.
#endregion

using ConfigGen.Core.ConfigurationSettings;

namespace ConfigGen.Core.SettingsLoader
{
    /// <summary>
    /// Interface to be implemented by classes responsible for combining settings collections with defaults
    /// </summary>
    public interface IDefaultSettingsCombiner
    {

        /// <summary>
        /// Returns the results of combining default settings with an existing <see cref="MachinesConfigurationCollection"/>
        /// </summary>
        /// <param name="localSettings">The settings from the settings file</param>
        /// <param name="defaultSettings">The default settings that will be used if not overriden by the localSettings</param>
        /// <returns>The results of the combination</returns>
        MachinesConfigurationCollection Combine(MachinesConfigurationCollection localSettings, MachinesConfigurationCollection defaultSettings);

    }
}