#region Copyright and License Notice
// Copyright (C)2010-2013 - Rob Levine and other contributors
// http://configgen.codeplex.com
// 
// This file is part of ConfigGen.
// 
// ConfigGen is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// ConfigGen is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License and 
// the GNU Lesser General Public License along with ConfigGen.  
// If not, see <http://www.gnu.org/licenses/>
#endregion

using System.IO;

namespace ConfigGen.Core.TemplateLoader
{
    /// <summary>
    /// Interface implemented by the <see cref="ITemplatePreferencesLoader"/> c;ass.
    /// </summary>
    public interface ITemplatePreferencesLoader
    {
        /// <summary>
        /// Returns the template preferences specified in the xml template, if any, and removed the template preferences node from the template.
        /// </summary>
        /// <param name="sourceTemplateStream">Stream containing the source template stream.</param>
        /// <param name="destinationTemplateStream">Stream into which to write the template after the preferences section has been extracted.</param>
        /// <returns>Template preferences, if any were specified, otherwise null.</returns>
        TemplatePreferences LoadPreferences(Stream sourceTemplateStream, Stream destinationTemplateStream);
    }
}